// Copyright (c) 2014-2022 NetEase, Inc.
// All right reserved.

import 'package:netease_common/netease_common.dart';
import 'package:netease_roomkit_interface/src/pigeon.dart';
import 'package:netease_roomkit_interface/src/platform_interface/roomkit_platform.dart';
import 'package:netease_roomkit_interface/src/types/roomkit_options.dart';

class MethodChannelRoomKit extends RoomKitPlatform {
  final _api = RoomKitApi();

  @override
  Future<VoidResult> initialize(NERoomKitOptions options) {
    return _api
        .initialize(
          InitializeRequest(
            appKey: options.appKey,
            extras: options.extras,
          ),
        ).then((value) => VoidResult(code: value.code, msg: value.msg));
  }

  @override
  Future<SDKVersions> get sdkVersions {
    return _api.sdkVersions();
  }
}
