// Autogenerated from Pigeon (v1.0.19), do not edit directly.
// See also: https://pub.dev/packages/pigeon
// ignore_for_file: public_member_api_docs, non_constant_identifier_names, avoid_as, unused_import, unnecessary_parenthesis, prefer_null_aware_operators, omit_local_variable_types, unused_shown_name
// @dart = 2.12
import 'dart:async';
import 'dart:typed_data' show Uint8List, Int32List, Int64List, Float64List;

import 'package:flutter/foundation.dart' show WriteBuffer, ReadBuffer;
import 'package:flutter/services.dart';

class SimpleResponse {
  SimpleResponse({
    required this.code,
    this.msg,
    this.data1,
    this.data2,
    this.data3,
  });

  int code;
  String? msg;
  int? data1;
  int? data2;
  String? data3;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['code'] = code;
    pigeonMap['msg'] = msg;
    pigeonMap['data1'] = data1;
    pigeonMap['data2'] = data2;
    pigeonMap['data3'] = data3;
    return pigeonMap;
  }

  static SimpleResponse decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return SimpleResponse(
      code: pigeonMap['code']! as int,
      msg: pigeonMap['msg'] as String?,
      data1: pigeonMap['data1'] as int?,
      data2: pigeonMap['data2'] as int?,
      data3: pigeonMap['data3'] as String?,
    );
  }
}

class InitializeRequest {
  InitializeRequest({
    required this.appKey,
    this.extras,
  });

  String appKey;
  Map<String?, String?>? extras;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['appKey'] = appKey;
    pigeonMap['extras'] = extras;
    return pigeonMap;
  }

  static InitializeRequest decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return InitializeRequest(
      appKey: pigeonMap['appKey']! as String,
      extras: (pigeonMap['extras'] as Map<Object?, Object?>?)?.cast<String?, String?>(),
    );
  }
}

class SDKVersions {
  SDKVersions({
    this.imVersion,
    this.rtcVersion,
    this.whiteboardVersion,
    this.roomKitVersion,
  });

  String? imVersion;
  String? rtcVersion;
  String? whiteboardVersion;
  String? roomKitVersion;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['imVersion'] = imVersion;
    pigeonMap['rtcVersion'] = rtcVersion;
    pigeonMap['whiteboardVersion'] = whiteboardVersion;
    pigeonMap['roomKitVersion'] = roomKitVersion;
    return pigeonMap;
  }

  static SDKVersions decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return SDKVersions(
      imVersion: pigeonMap['imVersion'] as String?,
      rtcVersion: pigeonMap['rtcVersion'] as String?,
      whiteboardVersion: pigeonMap['whiteboardVersion'] as String?,
      roomKitVersion: pigeonMap['roomKitVersion'] as String?,
    );
  }
}

class AuthStatusEvent {
  AuthStatusEvent({
    required this.status,
    required this.isLoggedIn,
  });

  String status;
  bool isLoggedIn;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['status'] = status;
    pigeonMap['isLoggedIn'] = isLoggedIn;
    return pigeonMap;
  }

  static AuthStatusEvent decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return AuthStatusEvent(
      status: pigeonMap['status']! as String,
      isLoggedIn: pigeonMap['isLoggedIn']! as bool,
    );
  }
}

class CreateRoomParams {
  CreateRoomParams({
    required this.roomUuid,
    required this.roomName,
    this.templateId,
    this.password,
    this.initialProperties,
  });

  String roomUuid;
  String roomName;
  String? templateId;
  String? password;
  Map<String?, String?>? initialProperties;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['roomName'] = roomName;
    pigeonMap['templateId'] = templateId;
    pigeonMap['password'] = password;
    pigeonMap['initialProperties'] = initialProperties;
    return pigeonMap;
  }

  static CreateRoomParams decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return CreateRoomParams(
      roomUuid: pigeonMap['roomUuid']! as String,
      roomName: pigeonMap['roomName']! as String,
      templateId: pigeonMap['templateId'] as String?,
      password: pigeonMap['password'] as String?,
      initialProperties: (pigeonMap['initialProperties'] as Map<Object?, Object?>?)?.cast<String?, String?>(),
    );
  }
}

class CreateRoomOptions {
  CreateRoomOptions({
    required this.enableRecord,
    required this.enableLive,
    required this.enableRtc,
    required this.enableChatroom,
    required this.enableWhiteboard,
  });

  bool enableRecord;
  bool enableLive;
  bool enableRtc;
  bool enableChatroom;
  bool enableWhiteboard;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['enableRecord'] = enableRecord;
    pigeonMap['enableLive'] = enableLive;
    pigeonMap['enableRtc'] = enableRtc;
    pigeonMap['enableChatroom'] = enableChatroom;
    pigeonMap['enableWhiteboard'] = enableWhiteboard;
    return pigeonMap;
  }

  static CreateRoomOptions decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return CreateRoomOptions(
      enableRecord: pigeonMap['enableRecord']! as bool,
      enableLive: pigeonMap['enableLive']! as bool,
      enableRtc: pigeonMap['enableRtc']! as bool,
      enableChatroom: pigeonMap['enableChatroom']! as bool,
      enableWhiteboard: pigeonMap['enableWhiteboard']! as bool,
    );
  }
}

class JoinRoomParams {
  JoinRoomParams({
    required this.roomUuid,
    required this.userName,
    required this.role,
    this.password,
    this.initialProperties,
  });

  String roomUuid;
  String userName;
  String role;
  String? password;
  Map<String?, String?>? initialProperties;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['userName'] = userName;
    pigeonMap['role'] = role;
    pigeonMap['password'] = password;
    pigeonMap['initialProperties'] = initialProperties;
    return pigeonMap;
  }

  static JoinRoomParams decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return JoinRoomParams(
      roomUuid: pigeonMap['roomUuid']! as String,
      userName: pigeonMap['userName']! as String,
      role: pigeonMap['role']! as String,
      password: pigeonMap['password'] as String?,
      initialProperties: (pigeonMap['initialProperties'] as Map<Object?, Object?>?)?.cast<String?, String?>(),
    );
  }
}

class JoinRoomOptions {
  JoinRoomOptions({
    required this.unUsed,
  });

  int unUsed;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['unUsed'] = unUsed;
    return pigeonMap;
  }

  static JoinRoomOptions decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return JoinRoomOptions(
      unUsed: pigeonMap['unUsed']! as int,
    );
  }
}

class PreviewRoomParams {
  PreviewRoomParams({
    this.value,
  });

  int? value;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['value'] = value;
    return pigeonMap;
  }

  static PreviewRoomParams decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return PreviewRoomParams(
      value: pigeonMap['value'] as int?,
    );
  }
}

class PreviewRoomOptions {
  PreviewRoomOptions({
    this.value,
  });

  int? value;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['value'] = value;
    return pigeonMap;
  }

  static PreviewRoomOptions decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return PreviewRoomOptions(
      value: pigeonMap['value'] as int?,
    );
  }
}

class RoomRole {
  RoomRole({
    required this.name,
    required this.limit,
    required this.superRole,
    this.params,
  });

  String name;
  int limit;
  bool superRole;
  RoleParams? params;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['name'] = name;
    pigeonMap['limit'] = limit;
    pigeonMap['superRole'] = superRole;
    pigeonMap['params'] = params == null ? null : params!.encode();
    return pigeonMap;
  }

  static RoomRole decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomRole(
      name: pigeonMap['name']! as String,
      limit: pigeonMap['limit']! as int,
      superRole: pigeonMap['superRole']! as bool,
      params: pigeonMap['params'] != null
          ? RoleParams.decode(pigeonMap['params']!)
          : null,
    );
  }
}

class RoleParams {
  RoleParams({
    this.video,
    this.audio,
    this.screen,
  });

  RoleVideoParams? video;
  RoleAudioParams? audio;
  RoleScreenParams? screen;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['video'] = video == null ? null : video!.encode();
    pigeonMap['audio'] = audio == null ? null : audio!.encode();
    pigeonMap['screen'] = screen == null ? null : screen!.encode();
    return pigeonMap;
  }

  static RoleParams decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoleParams(
      video: pigeonMap['video'] != null
          ? RoleVideoParams.decode(pigeonMap['video']!)
          : null,
      audio: pigeonMap['audio'] != null
          ? RoleAudioParams.decode(pigeonMap['audio']!)
          : null,
      screen: pigeonMap['screen'] != null
          ? RoleScreenParams.decode(pigeonMap['screen']!)
          : null,
    );
  }
}

class RoleVideoParams {
  RoleVideoParams({
    required this.width,
    required this.height,
    required this.fps,
  });

  int width;
  int height;
  int fps;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['width'] = width;
    pigeonMap['height'] = height;
    pigeonMap['fps'] = fps;
    return pigeonMap;
  }

  static RoleVideoParams decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoleVideoParams(
      width: pigeonMap['width']! as int,
      height: pigeonMap['height']! as int,
      fps: pigeonMap['fps']! as int,
    );
  }
}

class RoleScreenParams {
  RoleScreenParams({
    required this.videoProfile,
  });

  String videoProfile;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['videoProfile'] = videoProfile;
    return pigeonMap;
  }

  static RoleScreenParams decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoleScreenParams(
      videoProfile: pigeonMap['videoProfile']! as String,
    );
  }
}

class RoleAudioParams {
  RoleAudioParams({
    required this.profile,
    required this.scenario,
  });

  String profile;
  String scenario;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['profile'] = profile;
    pigeonMap['scenario'] = scenario;
    return pigeonMap;
  }

  static RoleAudioParams decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoleAudioParams(
      profile: pigeonMap['profile']! as String,
      scenario: pigeonMap['scenario']! as String,
    );
  }
}

class RoomMember {
  RoomMember({
    required this.uuid,
    required this.name,
    this.role,
    required this.isAudioOn,
    required this.isVideoOn,
    required this.isInRtcChannel,
    required this.isInChatroom,
    required this.isSharingScreen,
    required this.isSharingWhiteboard,
    this.properties,
  });

  String uuid;
  String name;
  RoomRole? role;
  bool isAudioOn;
  bool isVideoOn;
  bool isInRtcChannel;
  bool isInChatroom;
  bool isSharingScreen;
  bool isSharingWhiteboard;
  Map<String?, String?>? properties;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['uuid'] = uuid;
    pigeonMap['name'] = name;
    pigeonMap['role'] = role == null ? null : role!.encode();
    pigeonMap['isAudioOn'] = isAudioOn;
    pigeonMap['isVideoOn'] = isVideoOn;
    pigeonMap['isInRtcChannel'] = isInRtcChannel;
    pigeonMap['isInChatroom'] = isInChatroom;
    pigeonMap['isSharingScreen'] = isSharingScreen;
    pigeonMap['isSharingWhiteboard'] = isSharingWhiteboard;
    pigeonMap['properties'] = properties;
    return pigeonMap;
  }

  static RoomMember decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomMember(
      uuid: pigeonMap['uuid']! as String,
      name: pigeonMap['name']! as String,
      role: pigeonMap['role'] != null
          ? RoomRole.decode(pigeonMap['role']!)
          : null,
      isAudioOn: pigeonMap['isAudioOn']! as bool,
      isVideoOn: pigeonMap['isVideoOn']! as bool,
      isInRtcChannel: pigeonMap['isInRtcChannel']! as bool,
      isInChatroom: pigeonMap['isInChatroom']! as bool,
      isSharingScreen: pigeonMap['isSharingScreen']! as bool,
      isSharingWhiteboard: pigeonMap['isSharingWhiteboard']! as bool,
      properties: (pigeonMap['properties'] as Map<Object?, Object?>?)?.cast<String?, String?>(),
    );
  }
}

class RoomSnapshot {
  RoomSnapshot({
    required this.roomUuid,
    required this.roomName,
    this.password,
    required this.isRoomLocked,
    required this.rtcStartTime,
    this.localMember,
    required this.remoteMembers,
    this.properties,
    required this.isRtcSupported,
    required this.isChatroomSupported,
    required this.isWhiteboardSupported,
    required this.isCloudRecordSupported,
    required this.isLiveSupported,
  });

  String roomUuid;
  String roomName;
  String? password;
  bool isRoomLocked;
  int rtcStartTime;
  RoomMember? localMember;
  List<RoomMember?> remoteMembers;
  Map<String?, String?>? properties;
  bool isRtcSupported;
  bool isChatroomSupported;
  bool isWhiteboardSupported;
  bool isCloudRecordSupported;
  bool isLiveSupported;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['roomName'] = roomName;
    pigeonMap['password'] = password;
    pigeonMap['isRoomLocked'] = isRoomLocked;
    pigeonMap['rtcStartTime'] = rtcStartTime;
    pigeonMap['localMember'] = localMember == null ? null : localMember!.encode();
    pigeonMap['remoteMembers'] = remoteMembers;
    pigeonMap['properties'] = properties;
    pigeonMap['isRtcSupported'] = isRtcSupported;
    pigeonMap['isChatroomSupported'] = isChatroomSupported;
    pigeonMap['isWhiteboardSupported'] = isWhiteboardSupported;
    pigeonMap['isCloudRecordSupported'] = isCloudRecordSupported;
    pigeonMap['isLiveSupported'] = isLiveSupported;
    return pigeonMap;
  }

  static RoomSnapshot decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomSnapshot(
      roomUuid: pigeonMap['roomUuid']! as String,
      roomName: pigeonMap['roomName']! as String,
      password: pigeonMap['password'] as String?,
      isRoomLocked: pigeonMap['isRoomLocked']! as bool,
      rtcStartTime: pigeonMap['rtcStartTime']! as int,
      localMember: pigeonMap['localMember'] != null
          ? RoomMember.decode(pigeonMap['localMember']!)
          : null,
      remoteMembers: (pigeonMap['remoteMembers'] as List<Object?>?)!.cast<RoomMember?>(),
      properties: (pigeonMap['properties'] as Map<Object?, Object?>?)?.cast<String?, String?>(),
      isRtcSupported: pigeonMap['isRtcSupported']! as bool,
      isChatroomSupported: pigeonMap['isChatroomSupported']! as bool,
      isWhiteboardSupported: pigeonMap['isWhiteboardSupported']! as bool,
      isCloudRecordSupported: pigeonMap['isCloudRecordSupported']! as bool,
      isLiveSupported: pigeonMap['isLiveSupported']! as bool,
    );
  }
}

class JoinRoomResponse {
  JoinRoomResponse({
    required this.code,
    this.msg,
    this.snapshot,
  });

  int code;
  String? msg;
  RoomSnapshot? snapshot;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['code'] = code;
    pigeonMap['msg'] = msg;
    pigeonMap['snapshot'] = snapshot == null ? null : snapshot!.encode();
    return pigeonMap;
  }

  static JoinRoomResponse decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return JoinRoomResponse(
      code: pigeonMap['code']! as int,
      msg: pigeonMap['msg'] as String?,
      snapshot: pigeonMap['snapshot'] != null
          ? RoomSnapshot.decode(pigeonMap['snapshot']!)
          : null,
    );
  }
}

class RoomMessage {
  RoomMessage({
    required this.type,
    this.fromAccount,
    required this.fromNick,
    required this.content,
    this.toAccounts,
    required this.time,
  });

  String type;
  String? fromAccount;
  String fromNick;
  String content;
  List<String?>? toAccounts;
  int time;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['type'] = type;
    pigeonMap['fromAccount'] = fromAccount;
    pigeonMap['fromNick'] = fromNick;
    pigeonMap['content'] = content;
    pigeonMap['toAccounts'] = toAccounts;
    pigeonMap['time'] = time;
    return pigeonMap;
  }

  static RoomMessage decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomMessage(
      type: pigeonMap['type']! as String,
      fromAccount: pigeonMap['fromAccount'] as String?,
      fromNick: pigeonMap['fromNick']! as String,
      content: pigeonMap['content']! as String,
      toAccounts: (pigeonMap['toAccounts'] as List<Object?>?)?.cast<String?>(),
      time: pigeonMap['time']! as int,
    );
  }
}

class RoomMessageEvent {
  RoomMessageEvent({
    required this.roomUuid,
    required this.messages,
  });

  String roomUuid;
  List<RoomMessage?> messages;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['messages'] = messages;
    return pigeonMap;
  }

  static RoomMessageEvent decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomMessageEvent(
      roomUuid: pigeonMap['roomUuid']! as String,
      messages: (pigeonMap['messages'] as List<Object?>?)!.cast<RoomMessage?>(),
    );
  }
}

class PropertyEvent {
  PropertyEvent({
    required this.roomUuid,
    this.userUuid,
    required this.properties,
  });

  String roomUuid;
  String? userUuid;
  Map<String?, String?> properties;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['userUuid'] = userUuid;
    pigeonMap['properties'] = properties;
    return pigeonMap;
  }

  static PropertyEvent decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return PropertyEvent(
      roomUuid: pigeonMap['roomUuid']! as String,
      userUuid: pigeonMap['userUuid'] as String?,
      properties: (pigeonMap['properties'] as Map<Object?, Object?>?)!.cast<String?, String?>(),
    );
  }
}

class MemberRoleChangeEvent {
  MemberRoleChangeEvent({
    required this.roomUuid,
    required this.userUuid,
    this.role,
  });

  String roomUuid;
  String userUuid;
  RoomRole? role;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['userUuid'] = userUuid;
    pigeonMap['role'] = role == null ? null : role!.encode();
    return pigeonMap;
  }

  static MemberRoleChangeEvent decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return MemberRoleChangeEvent(
      roomUuid: pigeonMap['roomUuid']! as String,
      userUuid: pigeonMap['userUuid']! as String,
      role: pigeonMap['role'] != null
          ? RoomRole.decode(pigeonMap['role']!)
          : null,
    );
  }
}

class MembersEvent {
  MembersEvent({
    required this.roomUuid,
    this.members,
    this.uuids,
  });

  String roomUuid;
  List<RoomMember?>? members;
  List<String?>? uuids;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['members'] = members;
    pigeonMap['uuids'] = uuids;
    return pigeonMap;
  }

  static MembersEvent decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return MembersEvent(
      roomUuid: pigeonMap['roomUuid']! as String,
      members: (pigeonMap['members'] as List<Object?>?)?.cast<RoomMember?>(),
      uuids: (pigeonMap['uuids'] as List<Object?>?)?.cast<String?>(),
    );
  }
}

class CommonEvent {
  CommonEvent({
    required this.roomUuid,
    this.userUuid,
    this.arg1,
    this.arg2,
    this.sArg1,
    this.sArg2,
  });

  String roomUuid;
  String? userUuid;
  int? arg1;
  int? arg2;
  String? sArg1;
  String? sArg2;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['userUuid'] = userUuid;
    pigeonMap['arg1'] = arg1;
    pigeonMap['arg2'] = arg2;
    pigeonMap['sArg1'] = sArg1;
    pigeonMap['sArg2'] = sArg2;
    return pigeonMap;
  }

  static CommonEvent decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return CommonEvent(
      roomUuid: pigeonMap['roomUuid']! as String,
      userUuid: pigeonMap['userUuid'] as String?,
      arg1: pigeonMap['arg1'] as int?,
      arg2: pigeonMap['arg2'] as int?,
      sArg1: pigeonMap['sArg1'] as String?,
      sArg2: pigeonMap['sArg2'] as String?,
    );
  }
}

class MemberToggleEvent {
  MemberToggleEvent({
    required this.roomUuid,
    required this.userUuid,
    this.operateUuid,
    required this.isOn,
  });

  String roomUuid;
  String userUuid;
  String? operateUuid;
  bool isOn;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['userUuid'] = userUuid;
    pigeonMap['operateUuid'] = operateUuid;
    pigeonMap['isOn'] = isOn;
    return pigeonMap;
  }

  static MemberToggleEvent decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return MemberToggleEvent(
      roomUuid: pigeonMap['roomUuid']! as String,
      userUuid: pigeonMap['userUuid']! as String,
      operateUuid: pigeonMap['operateUuid'] as String?,
      isOn: pigeonMap['isOn']! as bool,
    );
  }
}

class RoomToggleEvent {
  RoomToggleEvent({
    required this.roomUuid,
    required this.isOn,
  });

  String roomUuid;
  bool isOn;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['isOn'] = isOn;
    return pigeonMap;
  }

  static RoomToggleEvent decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomToggleEvent(
      roomUuid: pigeonMap['roomUuid']! as String,
      isOn: pigeonMap['isOn']! as bool,
    );
  }
}

class MemberVolumeInfo {
  MemberVolumeInfo({
    required this.userUuid,
    required this.volume,
  });

  String userUuid;
  int volume;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['userUuid'] = userUuid;
    pigeonMap['volume'] = volume;
    return pigeonMap;
  }

  static MemberVolumeInfo decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return MemberVolumeInfo(
      userUuid: pigeonMap['userUuid']! as String,
      volume: pigeonMap['volume']! as int,
    );
  }
}

class RtcVolumeEvent {
  RtcVolumeEvent({
    required this.roomUuid,
    this.volumes,
    required this.totalVolume,
  });

  String roomUuid;
  List<MemberVolumeInfo?>? volumes;
  int totalVolume;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['volumes'] = volumes;
    pigeonMap['totalVolume'] = totalVolume;
    return pigeonMap;
  }

  static RtcVolumeEvent decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RtcVolumeEvent(
      roomUuid: pigeonMap['roomUuid']! as String,
      volumes: (pigeonMap['volumes'] as List<Object?>?)?.cast<MemberVolumeInfo?>(),
      totalVolume: pigeonMap['totalVolume']! as int,
    );
  }
}

class CreateAudioMixingOption {
  CreateAudioMixingOption({
    required this.path,
    required this.loopCount,
    required this.sendEnabled,
    required this.sendVolume,
    required this.playbackEnabled,
    required this.playbackVolume,
  });

  String path;
  int loopCount;
  bool sendEnabled;
  int sendVolume;
  bool playbackEnabled;
  int playbackVolume;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['path'] = path;
    pigeonMap['loopCount'] = loopCount;
    pigeonMap['sendEnabled'] = sendEnabled;
    pigeonMap['sendVolume'] = sendVolume;
    pigeonMap['playbackEnabled'] = playbackEnabled;
    pigeonMap['playbackVolume'] = playbackVolume;
    return pigeonMap;
  }

  static CreateAudioMixingOption decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return CreateAudioMixingOption(
      path: pigeonMap['path']! as String,
      loopCount: pigeonMap['loopCount']! as int,
      sendEnabled: pigeonMap['sendEnabled']! as bool,
      sendVolume: pigeonMap['sendVolume']! as int,
      playbackEnabled: pigeonMap['playbackEnabled']! as bool,
      playbackVolume: pigeonMap['playbackVolume']! as int,
    );
  }
}

class CreateAudioEffectOption {
  CreateAudioEffectOption({
    required this.path,
    required this.loopCount,
    required this.sendEnabled,
    required this.sendVolume,
    required this.playbackEnabled,
    required this.playbackVolume,
  });

  String path;
  int loopCount;
  bool sendEnabled;
  int sendVolume;
  bool playbackEnabled;
  int playbackVolume;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['path'] = path;
    pigeonMap['loopCount'] = loopCount;
    pigeonMap['sendEnabled'] = sendEnabled;
    pigeonMap['sendVolume'] = sendVolume;
    pigeonMap['playbackEnabled'] = playbackEnabled;
    pigeonMap['playbackVolume'] = playbackVolume;
    return pigeonMap;
  }

  static CreateAudioEffectOption decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return CreateAudioEffectOption(
      path: pigeonMap['path']! as String,
      loopCount: pigeonMap['loopCount']! as int,
      sendEnabled: pigeonMap['sendEnabled']! as bool,
      sendVolume: pigeonMap['sendVolume']! as int,
      playbackEnabled: pigeonMap['playbackEnabled']! as bool,
      playbackVolume: pigeonMap['playbackVolume']! as int,
    );
  }
}

class RoomLiveStreamTaskInfo {
  RoomLiveStreamTaskInfo({
    required this.taskID,
    required this.streamURL,
    required this.serverRecordEnabled,
    this.extraInfo,
    this.layout,
    this.config,
    required this.lsMode,
  });

  String taskID;
  String streamURL;
  bool serverRecordEnabled;
  String? extraInfo;
  RoomLiveStreamLayout? layout;
  RoomLiveConfig? config;
  int lsMode;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['taskID'] = taskID;
    pigeonMap['streamURL'] = streamURL;
    pigeonMap['serverRecordEnabled'] = serverRecordEnabled;
    pigeonMap['extraInfo'] = extraInfo;
    pigeonMap['layout'] = layout == null ? null : layout!.encode();
    pigeonMap['config'] = config == null ? null : config!.encode();
    pigeonMap['lsMode'] = lsMode;
    return pigeonMap;
  }

  static RoomLiveStreamTaskInfo decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomLiveStreamTaskInfo(
      taskID: pigeonMap['taskID']! as String,
      streamURL: pigeonMap['streamURL']! as String,
      serverRecordEnabled: pigeonMap['serverRecordEnabled']! as bool,
      extraInfo: pigeonMap['extraInfo'] as String?,
      layout: pigeonMap['layout'] != null
          ? RoomLiveStreamLayout.decode(pigeonMap['layout']!)
          : null,
      config: pigeonMap['config'] != null
          ? RoomLiveConfig.decode(pigeonMap['config']!)
          : null,
      lsMode: pigeonMap['lsMode']! as int,
    );
  }
}

class RoomLiveStreamLayout {
  RoomLiveStreamLayout({
    required this.width,
    required this.height,
    required this.backgroundColor,
    this.users,
    this.bgImage,
  });

  int width;
  int height;
  int backgroundColor;
  List<RoomLiveStreamUserTranscoding?>? users;
  RoomLiveStreamImageInfo? bgImage;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['width'] = width;
    pigeonMap['height'] = height;
    pigeonMap['backgroundColor'] = backgroundColor;
    pigeonMap['users'] = users;
    pigeonMap['bgImage'] = bgImage == null ? null : bgImage!.encode();
    return pigeonMap;
  }

  static RoomLiveStreamLayout decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomLiveStreamLayout(
      width: pigeonMap['width']! as int,
      height: pigeonMap['height']! as int,
      backgroundColor: pigeonMap['backgroundColor']! as int,
      users: (pigeonMap['users'] as List<Object?>?)?.cast<RoomLiveStreamUserTranscoding?>(),
      bgImage: pigeonMap['bgImage'] != null
          ? RoomLiveStreamImageInfo.decode(pigeonMap['bgImage']!)
          : null,
    );
  }
}

class RoomLiveStreamUserTranscoding {
  RoomLiveStreamUserTranscoding({
    required this.userUuid,
    required this.videoPush,
    required this.x,
    required this.y,
    required this.width,
    required this.height,
    required this.audioPush,
    required this.zOrder,
    required this.adaption,
  });

  String userUuid;
  bool videoPush;
  int x;
  int y;
  int width;
  int height;
  bool audioPush;
  int zOrder;
  int adaption;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['userUuid'] = userUuid;
    pigeonMap['videoPush'] = videoPush;
    pigeonMap['x'] = x;
    pigeonMap['y'] = y;
    pigeonMap['width'] = width;
    pigeonMap['height'] = height;
    pigeonMap['audioPush'] = audioPush;
    pigeonMap['zOrder'] = zOrder;
    pigeonMap['adaption'] = adaption;
    return pigeonMap;
  }

  static RoomLiveStreamUserTranscoding decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomLiveStreamUserTranscoding(
      userUuid: pigeonMap['userUuid']! as String,
      videoPush: pigeonMap['videoPush']! as bool,
      x: pigeonMap['x']! as int,
      y: pigeonMap['y']! as int,
      width: pigeonMap['width']! as int,
      height: pigeonMap['height']! as int,
      audioPush: pigeonMap['audioPush']! as bool,
      zOrder: pigeonMap['zOrder']! as int,
      adaption: pigeonMap['adaption']! as int,
    );
  }
}

class RoomLiveStreamImageInfo {
  RoomLiveStreamImageInfo({
    this.url,
    required this.x,
    required this.y,
    required this.width,
    required this.height,
  });

  String? url;
  int x;
  int y;
  int width;
  int height;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['url'] = url;
    pigeonMap['x'] = x;
    pigeonMap['y'] = y;
    pigeonMap['width'] = width;
    pigeonMap['height'] = height;
    return pigeonMap;
  }

  static RoomLiveStreamImageInfo decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomLiveStreamImageInfo(
      url: pigeonMap['url'] as String?,
      x: pigeonMap['x']! as int,
      y: pigeonMap['y']! as int,
      width: pigeonMap['width']! as int,
      height: pigeonMap['height']! as int,
    );
  }
}

class RoomLiveConfig {
  RoomLiveConfig({
    required this.singleVideoPassthrough,
    required this.audioBitrate,
    required this.sampleRate,
    required this.channels,
    required this.audioCodecProfile,
  });

  bool singleVideoPassthrough;
  int audioBitrate;
  int sampleRate;
  int channels;
  int audioCodecProfile;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['singleVideoPassthrough'] = singleVideoPassthrough;
    pigeonMap['audioBitrate'] = audioBitrate;
    pigeonMap['sampleRate'] = sampleRate;
    pigeonMap['channels'] = channels;
    pigeonMap['audioCodecProfile'] = audioCodecProfile;
    return pigeonMap;
  }

  static RoomLiveConfig decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomLiveConfig(
      singleVideoPassthrough: pigeonMap['singleVideoPassthrough']! as bool,
      audioBitrate: pigeonMap['audioBitrate']! as int,
      sampleRate: pigeonMap['sampleRate']! as int,
      channels: pigeonMap['channels']! as int,
      audioCodecProfile: pigeonMap['audioCodecProfile']! as int,
    );
  }
}

class StartScreenShareRequest {
  StartScreenShareRequest({
    required this.roomUuid,
    this.videoProfile,
    this.frameRate,
    this.iosAppGroup,
  });

  String roomUuid;
  int? videoProfile;
  int? frameRate;
  String? iosAppGroup;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['videoProfile'] = videoProfile;
    pigeonMap['frameRate'] = frameRate;
    pigeonMap['iosAppGroup'] = iosAppGroup;
    return pigeonMap;
  }

  static StartScreenShareRequest decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return StartScreenShareRequest(
      roomUuid: pigeonMap['roomUuid']! as String,
      videoProfile: pigeonMap['videoProfile'] as int?,
      frameRate: pigeonMap['frameRate'] as int?,
      iosAppGroup: pigeonMap['iosAppGroup'] as String?,
    );
  }
}

class PassThroughMessageEvent {
  PassThroughMessageEvent({
    this.roomUuid,
    this.senderUuid,
    required this.data,
    required this.subCmd,
  });

  String? roomUuid;
  String? senderUuid;
  String data;
  int subCmd;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['roomUuid'] = roomUuid;
    pigeonMap['senderUuid'] = senderUuid;
    pigeonMap['data'] = data;
    pigeonMap['subCmd'] = subCmd;
    return pigeonMap;
  }

  static PassThroughMessageEvent decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return PassThroughMessageEvent(
      roomUuid: pigeonMap['roomUuid'] as String?,
      senderUuid: pigeonMap['senderUuid'] as String?,
      data: pigeonMap['data']! as String,
      subCmd: pigeonMap['subCmd']! as int,
    );
  }
}

class RoomLiveRequest {
  RoomLiveRequest({
    required this.title,
    required this.liveLayout,
    this.password,
    this.liveUuids,
    this.extras,
  });

  String title;
  int liveLayout;
  String? password;
  List<String?>? liveUuids;
  String? extras;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['title'] = title;
    pigeonMap['liveLayout'] = liveLayout;
    pigeonMap['password'] = password;
    pigeonMap['liveUuids'] = liveUuids;
    pigeonMap['extras'] = extras;
    return pigeonMap;
  }

  static RoomLiveRequest decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomLiveRequest(
      title: pigeonMap['title']! as String,
      liveLayout: pigeonMap['liveLayout']! as int,
      password: pigeonMap['password'] as String?,
      liveUuids: (pigeonMap['liveUuids'] as List<Object?>?)?.cast<String?>(),
      extras: pigeonMap['extras'] as String?,
    );
  }
}

class RoomLiveInfo {
  RoomLiveInfo({
    this.taskId,
    this.pushUrl,
    this.chatRoomId,
    this.httpPullUrl,
    this.rtmpPullUrl,
    this.hlsPullUrl,
    this.title,
    this.liveLayout,
    this.password,
    this.liveUuids,
    this.state,
    this.extras,
  });

  String? taskId;
  String? pushUrl;
  String? chatRoomId;
  String? httpPullUrl;
  String? rtmpPullUrl;
  String? hlsPullUrl;
  String? title;
  int? liveLayout;
  String? password;
  List<String?>? liveUuids;
  int? state;
  String? extras;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['taskId'] = taskId;
    pigeonMap['pushUrl'] = pushUrl;
    pigeonMap['chatRoomId'] = chatRoomId;
    pigeonMap['httpPullUrl'] = httpPullUrl;
    pigeonMap['rtmpPullUrl'] = rtmpPullUrl;
    pigeonMap['hlsPullUrl'] = hlsPullUrl;
    pigeonMap['title'] = title;
    pigeonMap['liveLayout'] = liveLayout;
    pigeonMap['password'] = password;
    pigeonMap['liveUuids'] = liveUuids;
    pigeonMap['state'] = state;
    pigeonMap['extras'] = extras;
    return pigeonMap;
  }

  static RoomLiveInfo decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomLiveInfo(
      taskId: pigeonMap['taskId'] as String?,
      pushUrl: pigeonMap['pushUrl'] as String?,
      chatRoomId: pigeonMap['chatRoomId'] as String?,
      httpPullUrl: pigeonMap['httpPullUrl'] as String?,
      rtmpPullUrl: pigeonMap['rtmpPullUrl'] as String?,
      hlsPullUrl: pigeonMap['hlsPullUrl'] as String?,
      title: pigeonMap['title'] as String?,
      liveLayout: pigeonMap['liveLayout'] as int?,
      password: pigeonMap['password'] as String?,
      liveUuids: (pigeonMap['liveUuids'] as List<Object?>?)?.cast<String?>(),
      state: pigeonMap['state'] as int?,
      extras: pigeonMap['extras'] as String?,
    );
  }
}

class RoomLiveResponse {
  RoomLiveResponse({
    required this.code,
    this.msg,
    this.liveInfo,
  });

  int code;
  String? msg;
  RoomLiveInfo? liveInfo;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['code'] = code;
    pigeonMap['msg'] = msg;
    pigeonMap['liveInfo'] = liveInfo == null ? null : liveInfo!.encode();
    return pigeonMap;
  }

  static RoomLiveResponse decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return RoomLiveResponse(
      code: pigeonMap['code']! as int,
      msg: pigeonMap['msg'] as String?,
      liveInfo: pigeonMap['liveInfo'] != null
          ? RoomLiveInfo.decode(pigeonMap['liveInfo']!)
          : null,
    );
  }
}

class ChatRoomMember {
  ChatRoomMember({
    this.nick,
    this.avatar,
  });

  String? nick;
  String? avatar;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['nick'] = nick;
    pigeonMap['avatar'] = avatar;
    return pigeonMap;
  }

  static ChatRoomMember decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return ChatRoomMember(
      nick: pigeonMap['nick'] as String?,
      avatar: pigeonMap['avatar'] as String?,
    );
  }
}

class ChatRoomMembersResponse {
  ChatRoomMembersResponse({
    required this.code,
    this.msg,
    required this.chatRoomMembers,
  });

  int code;
  String? msg;
  List<ChatRoomMember?> chatRoomMembers;

  Object encode() {
    final Map<Object?, Object?> pigeonMap = <Object?, Object?>{};
    pigeonMap['code'] = code;
    pigeonMap['msg'] = msg;
    pigeonMap['chatRoomMembers'] = chatRoomMembers;
    return pigeonMap;
  }

  static ChatRoomMembersResponse decode(Object message) {
    final Map<Object?, Object?> pigeonMap = message as Map<Object?, Object?>;
    return ChatRoomMembersResponse(
      code: pigeonMap['code']! as int,
      msg: pigeonMap['msg'] as String?,
      chatRoomMembers: (pigeonMap['chatRoomMembers'] as List<Object?>?)!.cast<ChatRoomMember?>(),
    );
  }
}

class _RoomKitApiCodec extends StandardMessageCodec {
  const _RoomKitApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is InitializeRequest) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is SDKVersions) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
    if (value is SimpleResponse) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return InitializeRequest.decode(readValue(buffer)!);
      
      case 129:       
        return SDKVersions.decode(readValue(buffer)!);
      
      case 130:       
        return SimpleResponse.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class RoomKitApi {
  /// Constructor for [RoomKitApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  RoomKitApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _RoomKitApiCodec();

  Future<SimpleResponse> initialize(InitializeRequest arg_options) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomKitApi.initialize', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_options]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SDKVersions> sdkVersions() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomKitApi.sdkVersions', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SDKVersions?)!;
    }
  }
}

class _AuthServiceApiCodec extends StandardMessageCodec {
  const _AuthServiceApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is SimpleResponse) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return SimpleResponse.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class AuthServiceApi {
  /// Constructor for [AuthServiceApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  AuthServiceApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _AuthServiceApiCodec();

  Future<SimpleResponse> login(String arg_account, String arg_token) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AuthServiceApi.login', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_account, arg_token]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> anonymousLogin(String arg_authorization) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AuthServiceApi.anonymousLogin', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_authorization]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> logout() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AuthServiceApi.logout', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<bool> isLoggedIn() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AuthServiceApi.isLoggedIn', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as bool?)!;
    }
  }
}

class _AuthStatusEventSinkCodec extends StandardMessageCodec {
  const _AuthStatusEventSinkCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is AuthStatusEvent) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return AuthStatusEvent.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}
abstract class AuthStatusEventSink {
  static const MessageCodec<Object?> codec = _AuthStatusEventSinkCodec();

  void onAuthStatusChanged(AuthStatusEvent event);
  static void setup(AuthStatusEventSink? api, {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.AuthStatusEventSink.onAuthStatusChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.AuthStatusEventSink.onAuthStatusChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final AuthStatusEvent? arg_event = (args[0] as AuthStatusEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.AuthStatusEventSink.onAuthStatusChanged was null, expected non-null AuthStatusEvent.');
          api.onAuthStatusChanged(arg_event!);
          return;
        });
      }
    }
  }
}

class _RoomServiceApiCodec extends StandardMessageCodec {
  const _RoomServiceApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is CreateRoomOptions) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is CreateRoomParams) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
    if (value is JoinRoomOptions) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else 
    if (value is JoinRoomParams) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else 
    if (value is JoinRoomResponse) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else 
    if (value is PreviewRoomOptions) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else 
    if (value is PreviewRoomParams) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoleAudioParams) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoleParams) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoleScreenParams) {
      buffer.putUint8(137);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoleVideoParams) {
      buffer.putUint8(138);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomMember) {
      buffer.putUint8(139);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomRole) {
      buffer.putUint8(140);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomSnapshot) {
      buffer.putUint8(141);
      writeValue(buffer, value.encode());
    } else 
    if (value is SimpleResponse) {
      buffer.putUint8(142);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return CreateRoomOptions.decode(readValue(buffer)!);
      
      case 129:       
        return CreateRoomParams.decode(readValue(buffer)!);
      
      case 130:       
        return JoinRoomOptions.decode(readValue(buffer)!);
      
      case 131:       
        return JoinRoomParams.decode(readValue(buffer)!);
      
      case 132:       
        return JoinRoomResponse.decode(readValue(buffer)!);
      
      case 133:       
        return PreviewRoomOptions.decode(readValue(buffer)!);
      
      case 134:       
        return PreviewRoomParams.decode(readValue(buffer)!);
      
      case 135:       
        return RoleAudioParams.decode(readValue(buffer)!);
      
      case 136:       
        return RoleParams.decode(readValue(buffer)!);
      
      case 137:       
        return RoleScreenParams.decode(readValue(buffer)!);
      
      case 138:       
        return RoleVideoParams.decode(readValue(buffer)!);
      
      case 139:       
        return RoomMember.decode(readValue(buffer)!);
      
      case 140:       
        return RoomRole.decode(readValue(buffer)!);
      
      case 141:       
        return RoomSnapshot.decode(readValue(buffer)!);
      
      case 142:       
        return SimpleResponse.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class RoomServiceApi {
  /// Constructor for [RoomServiceApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  RoomServiceApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _RoomServiceApiCodec();

  Future<SimpleResponse> createRoom(CreateRoomParams arg_params, CreateRoomOptions arg_options) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomServiceApi.createRoom', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_params, arg_options]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<JoinRoomResponse> joinRoom(JoinRoomParams arg_params, JoinRoomOptions arg_options) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomServiceApi.joinRoom', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_params, arg_options]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as JoinRoomResponse?)!;
    }
  }

  Future<SimpleResponse> previewRoom(PreviewRoomParams arg_params, PreviewRoomOptions arg_options) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomServiceApi.previewRoom', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_params, arg_options]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }
}

class _RoomContextApiCodec extends StandardMessageCodec {
  const _RoomContextApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is SimpleResponse) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return SimpleResponse.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class RoomContextApi {
  /// Constructor for [RoomContextApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  RoomContextApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _RoomContextApiCodec();

  Future<SimpleResponse> changeMyName(String arg_roomUuid, String arg_name) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.changeMyName', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_name]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> changeMemberRole(String arg_roomUuid, String arg_userUuid, String arg_role) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.changeMemberRole', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuid, arg_role]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> handOverMyRole(String arg_roomUuid, String arg_userUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.handOverMyRole', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> kickMemberOut(String arg_roomUuid, String arg_userUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.kickMemberOut', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> leaveRoom(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.leaveRoom', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> endRoom(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.endRoom', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> updateRoomProperty(String arg_roomUuid, String arg_key, String arg_value, String arg_associatedUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.updateRoomProperty', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_key, arg_value, arg_associatedUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> deleteRoomProperty(String arg_roomUuid, String arg_key) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.deleteRoomProperty', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_key]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> updateMemberProperty(String arg_roomUuid, String arg_userUuid, String arg_key, String arg_value) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.updateMemberProperty', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuid, arg_key, arg_value]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> deleteMemberProperty(String arg_roomUuid, String arg_userUuid, String arg_key) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.deleteMemberProperty', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuid, arg_key]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> lockRoom(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.lockRoom', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> unlockRoom(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomContextApi.unlockRoom', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }
}

class _RoomEventSinkCodec extends StandardMessageCodec {
  const _RoomEventSinkCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is CommonEvent) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is MemberRoleChangeEvent) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
    if (value is MemberToggleEvent) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else 
    if (value is MemberVolumeInfo) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else 
    if (value is MembersEvent) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else 
    if (value is PropertyEvent) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoleAudioParams) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoleParams) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoleScreenParams) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoleVideoParams) {
      buffer.putUint8(137);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomMember) {
      buffer.putUint8(138);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomMessage) {
      buffer.putUint8(139);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomMessageEvent) {
      buffer.putUint8(140);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomRole) {
      buffer.putUint8(141);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomToggleEvent) {
      buffer.putUint8(142);
      writeValue(buffer, value.encode());
    } else 
    if (value is RtcVolumeEvent) {
      buffer.putUint8(143);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return CommonEvent.decode(readValue(buffer)!);
      
      case 129:       
        return MemberRoleChangeEvent.decode(readValue(buffer)!);
      
      case 130:       
        return MemberToggleEvent.decode(readValue(buffer)!);
      
      case 131:       
        return MemberVolumeInfo.decode(readValue(buffer)!);
      
      case 132:       
        return MembersEvent.decode(readValue(buffer)!);
      
      case 133:       
        return PropertyEvent.decode(readValue(buffer)!);
      
      case 134:       
        return RoleAudioParams.decode(readValue(buffer)!);
      
      case 135:       
        return RoleParams.decode(readValue(buffer)!);
      
      case 136:       
        return RoleScreenParams.decode(readValue(buffer)!);
      
      case 137:       
        return RoleVideoParams.decode(readValue(buffer)!);
      
      case 138:       
        return RoomMember.decode(readValue(buffer)!);
      
      case 139:       
        return RoomMessage.decode(readValue(buffer)!);
      
      case 140:       
        return RoomMessageEvent.decode(readValue(buffer)!);
      
      case 141:       
        return RoomRole.decode(readValue(buffer)!);
      
      case 142:       
        return RoomToggleEvent.decode(readValue(buffer)!);
      
      case 143:       
        return RtcVolumeEvent.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}
abstract class RoomEventSink {
  static const MessageCodec<Object?> codec = _RoomEventSinkCodec();

  void onRoomEnd(String roomUuid, String reason);
  void onRoomPropertiesChanged(PropertyEvent event);
  void onRoomPropertiesDeleted(PropertyEvent event);
  void onMemberPropertiesChanged(PropertyEvent event);
  void onMemberPropertiesDeleted(PropertyEvent event);
  void onMemberRoleChanged(MemberRoleChangeEvent event);
  void onMemberNameChanged(CommonEvent event);
  void onMemberJoinRoom(MembersEvent event);
  void onMemberLeaveRoom(MembersEvent event);
  void onMemberJoinRtcChannel(MembersEvent event);
  void onMemberLeaveRtcChannel(MembersEvent event);
  void onRtcChannelError(CommonEvent event);
  void onMemberJoinChatroom(MembersEvent event);
  void onMemberLeaveChatroom(MembersEvent event);
  void onMemberAudioMuteChanged(MemberToggleEvent event);
  void onMemberVideoMuteChanged(MemberToggleEvent event);
  void onMemberScreenShareStateChanged(MemberToggleEvent event);
  void onReceiveChatroomMessages(RoomMessageEvent messages);
  void onMemberWhiteboardShareStateChanged(MemberToggleEvent event);
  void onWhiteboardError(CommonEvent event);
  void onRoomLockStateChanged(RoomToggleEvent event);
  void onRoomLiveStateChanged(CommonEvent event);
  void onRtcAudioVolumeIndication(RtcVolumeEvent event);
  void onRtcAudioOutputDeviceChanged(CommonEvent event);
  static void setup(RoomEventSink? api, {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onRoomEnd', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRoomEnd was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final String? arg_roomUuid = (args[0] as String?);
          assert(arg_roomUuid != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRoomEnd was null, expected non-null String.');
          final String? arg_reason = (args[1] as String?);
          assert(arg_reason != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRoomEnd was null, expected non-null String.');
          api.onRoomEnd(arg_roomUuid!, arg_reason!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onRoomPropertiesChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRoomPropertiesChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PropertyEvent? arg_event = (args[0] as PropertyEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRoomPropertiesChanged was null, expected non-null PropertyEvent.');
          api.onRoomPropertiesChanged(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onRoomPropertiesDeleted', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRoomPropertiesDeleted was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PropertyEvent? arg_event = (args[0] as PropertyEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRoomPropertiesDeleted was null, expected non-null PropertyEvent.');
          api.onRoomPropertiesDeleted(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberPropertiesChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberPropertiesChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PropertyEvent? arg_event = (args[0] as PropertyEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberPropertiesChanged was null, expected non-null PropertyEvent.');
          api.onMemberPropertiesChanged(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberPropertiesDeleted', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberPropertiesDeleted was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PropertyEvent? arg_event = (args[0] as PropertyEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberPropertiesDeleted was null, expected non-null PropertyEvent.');
          api.onMemberPropertiesDeleted(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberRoleChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberRoleChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MemberRoleChangeEvent? arg_event = (args[0] as MemberRoleChangeEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberRoleChanged was null, expected non-null MemberRoleChangeEvent.');
          api.onMemberRoleChanged(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberNameChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberNameChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final CommonEvent? arg_event = (args[0] as CommonEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberNameChanged was null, expected non-null CommonEvent.');
          api.onMemberNameChanged(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberJoinRoom', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberJoinRoom was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MembersEvent? arg_event = (args[0] as MembersEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberJoinRoom was null, expected non-null MembersEvent.');
          api.onMemberJoinRoom(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberLeaveRoom', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberLeaveRoom was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MembersEvent? arg_event = (args[0] as MembersEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberLeaveRoom was null, expected non-null MembersEvent.');
          api.onMemberLeaveRoom(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberJoinRtcChannel', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberJoinRtcChannel was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MembersEvent? arg_event = (args[0] as MembersEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberJoinRtcChannel was null, expected non-null MembersEvent.');
          api.onMemberJoinRtcChannel(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberLeaveRtcChannel', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberLeaveRtcChannel was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MembersEvent? arg_event = (args[0] as MembersEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberLeaveRtcChannel was null, expected non-null MembersEvent.');
          api.onMemberLeaveRtcChannel(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onRtcChannelError', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRtcChannelError was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final CommonEvent? arg_event = (args[0] as CommonEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRtcChannelError was null, expected non-null CommonEvent.');
          api.onRtcChannelError(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberJoinChatroom', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberJoinChatroom was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MembersEvent? arg_event = (args[0] as MembersEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberJoinChatroom was null, expected non-null MembersEvent.');
          api.onMemberJoinChatroom(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberLeaveChatroom', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberLeaveChatroom was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MembersEvent? arg_event = (args[0] as MembersEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberLeaveChatroom was null, expected non-null MembersEvent.');
          api.onMemberLeaveChatroom(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberAudioMuteChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberAudioMuteChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MemberToggleEvent? arg_event = (args[0] as MemberToggleEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberAudioMuteChanged was null, expected non-null MemberToggleEvent.');
          api.onMemberAudioMuteChanged(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberVideoMuteChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberVideoMuteChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MemberToggleEvent? arg_event = (args[0] as MemberToggleEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberVideoMuteChanged was null, expected non-null MemberToggleEvent.');
          api.onMemberVideoMuteChanged(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberScreenShareStateChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberScreenShareStateChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MemberToggleEvent? arg_event = (args[0] as MemberToggleEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberScreenShareStateChanged was null, expected non-null MemberToggleEvent.');
          api.onMemberScreenShareStateChanged(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onReceiveChatroomMessages', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onReceiveChatroomMessages was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final RoomMessageEvent? arg_messages = (args[0] as RoomMessageEvent?);
          assert(arg_messages != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onReceiveChatroomMessages was null, expected non-null RoomMessageEvent.');
          api.onReceiveChatroomMessages(arg_messages!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onMemberWhiteboardShareStateChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberWhiteboardShareStateChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MemberToggleEvent? arg_event = (args[0] as MemberToggleEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onMemberWhiteboardShareStateChanged was null, expected non-null MemberToggleEvent.');
          api.onMemberWhiteboardShareStateChanged(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onWhiteboardError', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onWhiteboardError was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final CommonEvent? arg_event = (args[0] as CommonEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onWhiteboardError was null, expected non-null CommonEvent.');
          api.onWhiteboardError(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onRoomLockStateChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRoomLockStateChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final RoomToggleEvent? arg_event = (args[0] as RoomToggleEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRoomLockStateChanged was null, expected non-null RoomToggleEvent.');
          api.onRoomLockStateChanged(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onRoomLiveStateChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRoomLiveStateChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final CommonEvent? arg_event = (args[0] as CommonEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRoomLiveStateChanged was null, expected non-null CommonEvent.');
          api.onRoomLiveStateChanged(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onRtcAudioVolumeIndication', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRtcAudioVolumeIndication was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final RtcVolumeEvent? arg_event = (args[0] as RtcVolumeEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRtcAudioVolumeIndication was null, expected non-null RtcVolumeEvent.');
          api.onRtcAudioVolumeIndication(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.RoomEventSink.onRtcAudioOutputDeviceChanged', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRtcAudioOutputDeviceChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final CommonEvent? arg_event = (args[0] as CommonEvent?);
          assert(arg_event != null, 'Argument for dev.flutter.pigeon.RoomEventSink.onRtcAudioOutputDeviceChanged was null, expected non-null CommonEvent.');
          api.onRtcAudioOutputDeviceChanged(arg_event!);
          return;
        });
      }
    }
  }
}

class _RoomChatControllerApiCodec extends StandardMessageCodec {
  const _RoomChatControllerApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is ChatRoomMember) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is ChatRoomMembersResponse) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
    if (value is SimpleResponse) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return ChatRoomMember.decode(readValue(buffer)!);
      
      case 129:       
        return ChatRoomMembersResponse.decode(readValue(buffer)!);
      
      case 130:       
        return SimpleResponse.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class RoomChatControllerApi {
  /// Constructor for [RoomChatControllerApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  RoomChatControllerApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _RoomChatControllerApiCodec();

  Future<SimpleResponse> joinChatroom(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomChatControllerApi.joinChatroom', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> leaveChatroom(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomChatControllerApi.leaveChatroom', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> sendBroadcastTextMessage(String arg_roomUuid, String arg_message) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomChatControllerApi.sendBroadcastTextMessage', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_message]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> sendDirectTextMessage(String arg_roomUuid, String arg_userUuid, String arg_message) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomChatControllerApi.sendDirectTextMessage', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuid, arg_message]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> sendGroupTextMessage(String arg_roomUuid, List<String?> arg_userUuids, String arg_message) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomChatControllerApi.sendGroupTextMessage', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuids, arg_message]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<ChatRoomMembersResponse> fetchChatRoomMembers(String arg_roomUuid, int arg_queryType, int arg_limit) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomChatControllerApi.fetchChatRoomMembers', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_queryType, arg_limit]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as ChatRoomMembersResponse?)!;
    }
  }
}

class _RoomRtcControllerApiCodec extends StandardMessageCodec {
  const _RoomRtcControllerApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is CreateAudioEffectOption) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is CreateAudioMixingOption) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
    if (value is SimpleResponse) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else 
    if (value is StartScreenShareRequest) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return CreateAudioEffectOption.decode(readValue(buffer)!);
      
      case 129:       
        return CreateAudioMixingOption.decode(readValue(buffer)!);
      
      case 130:       
        return SimpleResponse.decode(readValue(buffer)!);
      
      case 131:       
        return StartScreenShareRequest.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class RoomRtcControllerApi {
  /// Constructor for [RoomRtcControllerApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  RoomRtcControllerApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _RoomRtcControllerApiCodec();

  Future<SimpleResponse> joinRtcChannel(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.joinRtcChannel', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> leaveRtcChannel(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.leaveRtcChannel', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> muteMyAudio(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.muteMyAudio', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> unmuteMyAudio(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.unmuteMyAudio', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> muteMemberAudio(String arg_roomUuid, String arg_uuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.muteMemberAudio', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_uuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> unmuteMemberAudio(String arg_roomUuid, String arg_uuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.unmuteMemberAudio', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_uuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> muteMemberVideo(String arg_roomUuid, String arg_uuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.muteMemberVideo', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_uuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> unmuteMemberVideo(String arg_roomUuid, String arg_uuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.unmuteMemberVideo', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_uuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> unmuteMyVideo(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.unmuteMyVideo', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> muteMyVideo(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.muteMyVideo', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopScreenShare(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.stopScreenShare', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> startScreenShare(StartScreenShareRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.startScreenShare', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_request]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopMemberScreenShare(String arg_roomUuid, String arg_uuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.stopMemberScreenShare', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_uuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> subscribeRemoteVideoStream(String arg_roomUuid, String arg_userUuid, bool arg_subscribe) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.subscribeRemoteVideoStream', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuid, arg_subscribe]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> subscribeRemoteSubStreamVideo(String arg_roomUuid, String arg_userUuid, bool arg_subscribe) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.subscribeRemoteSubStreamVideo', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuid, arg_subscribe]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setSpeakerphoneOn(String arg_roomUuid, bool arg_on) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.setSpeakerphoneOn', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_on]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> isSpeakerphoneOn(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.isSpeakerphoneOn', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopAudioDump(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.stopAudioDump', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> startAudioDump(String arg_roomUuid, int arg_type) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.startAudioDump', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_type]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> enableAudioVolumeIndication(String arg_roomUuid, bool arg_enable, int arg_interval) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.enableAudioVolumeIndication', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_enable, arg_interval]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> startRtcChannelMediaRelay(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.startRtcChannelMediaRelay', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopRtcChannelMediaRelay(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.stopRtcChannelMediaRelay', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> enableEarBack(String arg_roomUuid, bool arg_enable, int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.enableEarBack', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_enable, arg_volume]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> startAudioMixing(String arg_roomUuid, CreateAudioMixingOption arg_option) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.startAudioMixing', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_option]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> playEffect(String arg_roomUuid, int arg_id, CreateAudioEffectOption arg_option) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.playEffect', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_id, arg_option]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopAudioMixing(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.stopAudioMixing', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopEffect(String arg_roomUuid, int arg_id) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.stopEffect', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_id]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setAudioMixingSendVolume(String arg_roomUuid, int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.setAudioMixingSendVolume', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_volume]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setAudioMixingPlaybackVolume(String arg_roomUuid, int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.setAudioMixingPlaybackVolume', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_volume]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setEffectSendVolume(String arg_roomUuid, int arg_id, int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.setEffectSendVolume', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_id, arg_volume]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setEffectPlaybackVolume(String arg_roomUuid, int arg_id, int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.setEffectPlaybackVolume', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_id, arg_volume]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopAllEffects(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.stopAllEffects', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> adjustUserPlaybackSignalVolume(String arg_roomUuid, String arg_userUuid, int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.adjustUserPlaybackSignalVolume', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuid, arg_volume]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> switchCamera() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.switchCamera', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> addBeautyFilter(String arg_path) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.addBeautyFilter', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_path]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> addBeautySticker(String arg_path) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.addBeautySticker', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_path]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> enableBeauty(bool arg_isOpenBeauty) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.enableBeauty', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_isOpenBeauty]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> removeBeautyFilter() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.removeBeautyFilter', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> removeBeautySticker() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.removeBeautySticker', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> startBeauty() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.startBeauty', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopBeauty() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.stopBeauty', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setBeautyFilterLevel(double arg_level) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.setBeautyFilterLevel', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_level]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setBeautyEffect(int arg_beautyType, double arg_level) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcControllerApi.setBeautyEffect', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_beautyType, arg_level]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }
}

class _PreviewRoomRtcControllerApiCodec extends StandardMessageCodec {
  const _PreviewRoomRtcControllerApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is SimpleResponse) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return SimpleResponse.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class PreviewRoomRtcControllerApi {
  /// Constructor for [PreviewRoomRtcControllerApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  PreviewRoomRtcControllerApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _PreviewRoomRtcControllerApiCodec();

  Future<SimpleResponse> startPreview() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.startPreview', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopPreview() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.stopPreview', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> switchCamera() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.switchCamera', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> addBeautyFilter(String arg_path) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.addBeautyFilter', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_path]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> addBeautySticker(String arg_path) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.addBeautySticker', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_path]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> enableBeauty(bool arg_isOpenBeauty) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.enableBeauty', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_isOpenBeauty]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> removeBeautyFilter() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.removeBeautyFilter', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> removeBeautySticker() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.removeBeautySticker', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> startBeauty() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.startBeauty', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopBeauty() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.stopBeauty', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(null) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setBeautyFilterLevel(double arg_level) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.setBeautyFilterLevel', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_level]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setBeautyEffect(int arg_beautyType, double arg_level) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.PreviewRoomRtcControllerApi.setBeautyEffect', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_beautyType, arg_level]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }
}

class _RoomRtcVideoRenderCodec extends StandardMessageCodec {
  const _RoomRtcVideoRenderCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is SimpleResponse) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return SimpleResponse.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class RoomRtcVideoRender {
  /// Constructor for [RoomRtcVideoRender].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  RoomRtcVideoRender({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _RoomRtcVideoRenderCodec();

  Future<SimpleResponse> createVideoRenderer(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcVideoRender.createVideoRenderer', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setupLocalVideoRenderer(int arg_textureId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcVideoRender.setupLocalVideoRenderer', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_textureId]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setMirror(int arg_textureId, bool arg_mirror) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcVideoRender.setMirror', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_textureId, arg_mirror]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setupRemoteSubStreamVideoRenderer(String arg_userUuid, int arg_textureId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcVideoRender.setupRemoteSubStreamVideoRenderer', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_userUuid, arg_textureId]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setupRemoteVideoRenderer(String arg_userUuid, int arg_textureId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcVideoRender.setupRemoteVideoRenderer', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_userUuid, arg_textureId]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> disposeVideoRenderer(int arg_textureId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomRtcVideoRender.disposeVideoRenderer', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_textureId]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }
}

class _RoomWhiteboardControllerApiCodec extends StandardMessageCodec {
  const _RoomWhiteboardControllerApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is SimpleResponse) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return SimpleResponse.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class RoomWhiteboardControllerApi {
  /// Constructor for [RoomWhiteboardControllerApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  RoomWhiteboardControllerApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _RoomWhiteboardControllerApiCodec();

  Future<SimpleResponse> startWhiteboardShare(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomWhiteboardControllerApi.startWhiteboardShare', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopWhiteboardShare(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomWhiteboardControllerApi.stopWhiteboardShare', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> setEnableDraw(String arg_roomUuid, bool arg_enable) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomWhiteboardControllerApi.setEnableDraw', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_enable]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> stopMemberWhiteboardShare(String arg_roomUuid, String arg_userUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomWhiteboardControllerApi.stopMemberWhiteboardShare', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }
}

class _MessageEventSinkCodec extends StandardMessageCodec {
  const _MessageEventSinkCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is PassThroughMessageEvent) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return PassThroughMessageEvent.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}
abstract class MessageEventSink {
  static const MessageCodec<Object?> codec = _MessageEventSinkCodec();

  void onReceivePassThroughMessage(PassThroughMessageEvent messageEvent);
  static void setup(MessageEventSink? api, {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.MessageEventSink.onReceivePassThroughMessage', codec, binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null, 'Argument for dev.flutter.pigeon.MessageEventSink.onReceivePassThroughMessage was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PassThroughMessageEvent? arg_messageEvent = (args[0] as PassThroughMessageEvent?);
          assert(arg_messageEvent != null, 'Argument for dev.flutter.pigeon.MessageEventSink.onReceivePassThroughMessage was null, expected non-null PassThroughMessageEvent.');
          api.onReceivePassThroughMessage(arg_messageEvent!);
          return;
        });
      }
    }
  }
}

class _MessageServiceApiCodec extends StandardMessageCodec {
  const _MessageServiceApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is SimpleResponse) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return SimpleResponse.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class MessageServiceApi {
  /// Constructor for [MessageServiceApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  MessageServiceApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _MessageServiceApiCodec();

  Future<SimpleResponse> sendPassThroughMessage(String arg_roomUuid, String arg_userUuid, String arg_data) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.MessageServiceApi.sendPassThroughMessage', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_userUuid, arg_data]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }
}

class _RoomLiveControllerApiCodec extends StandardMessageCodec {
  const _RoomLiveControllerApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is RoomLiveConfig) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomLiveInfo) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomLiveRequest) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomLiveResponse) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomLiveStreamImageInfo) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomLiveStreamLayout) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomLiveStreamTaskInfo) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else 
    if (value is RoomLiveStreamUserTranscoding) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else 
    if (value is SimpleResponse) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else 
{
      super.writeValue(buffer, value);
    }
  }
  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:       
        return RoomLiveConfig.decode(readValue(buffer)!);
      
      case 129:       
        return RoomLiveInfo.decode(readValue(buffer)!);
      
      case 130:       
        return RoomLiveRequest.decode(readValue(buffer)!);
      
      case 131:       
        return RoomLiveResponse.decode(readValue(buffer)!);
      
      case 132:       
        return RoomLiveStreamImageInfo.decode(readValue(buffer)!);
      
      case 133:       
        return RoomLiveStreamLayout.decode(readValue(buffer)!);
      
      case 134:       
        return RoomLiveStreamTaskInfo.decode(readValue(buffer)!);
      
      case 135:       
        return RoomLiveStreamUserTranscoding.decode(readValue(buffer)!);
      
      case 136:       
        return SimpleResponse.decode(readValue(buffer)!);
      
      default:      
        return super.readValueOfType(type, buffer);
      
    }
  }
}

class RoomLiveControllerApi {
  /// Constructor for [RoomLiveControllerApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  RoomLiveControllerApi({BinaryMessenger? binaryMessenger}) : _binaryMessenger = binaryMessenger;

  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _RoomLiveControllerApiCodec();

  Future<RoomLiveResponse> startLive(String arg_roomUuid, RoomLiveRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomLiveControllerApi.startLive', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_request]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as RoomLiveResponse?)!;
    }
  }

  Future<SimpleResponse> stopLive(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomLiveControllerApi.stopLive', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<RoomLiveResponse> updateLive(String arg_roomUuid, RoomLiveRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomLiveControllerApi.updateLive', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_request]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as RoomLiveResponse?)!;
    }
  }

  Future<RoomLiveResponse> getLiveInfo(String arg_roomUuid) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomLiveControllerApi.getLiveInfo', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as RoomLiveResponse?)!;
    }
  }

  Future<SimpleResponse> addLiveStreamTask(String arg_roomUuid, RoomLiveStreamTaskInfo arg_taskInfo) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomLiveControllerApi.addLiveStreamTask', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_taskInfo]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> updateLiveStreamTask(String arg_roomUuid, RoomLiveStreamTaskInfo arg_taskInfo) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomLiveControllerApi.updateLiveStreamTask', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_taskInfo]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }

  Future<SimpleResponse> removeLiveStreamTask(String arg_roomUuid, String arg_taskID) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.RoomLiveControllerApi.removeLiveStreamTask', codec, binaryMessenger: _binaryMessenger);
    final Map<Object?, Object?>? replyMap =
        await channel.send(<Object>[arg_roomUuid, arg_taskID]) as Map<Object?, Object?>?;
    if (replyMap == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyMap['error'] != null) {
      final Map<Object?, Object?> error = (replyMap['error'] as Map<Object?, Object?>?)!;
      throw PlatformException(
        code: (error['code'] as String?)!,
        message: error['message'] as String?,
        details: error['details'],
      );
    } else if (replyMap['result'] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyMap['result'] as SimpleResponse?)!;
    }
  }
}
