import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:netease_common/netease_common.dart';
import 'package:netease_roomkit_interface/src/method_channel/method_channel_message_service.dart';
import 'package:netease_roomkit_interface/src/pigeon.dart';

abstract class MessageServicePlatform extends PlatformInterface{
  static final Object _token = Object();

  MessageServicePlatform() : super(token: _token);

  static  MessageServicePlatform _instance = MethodChannelMessageService();

  static MessageServicePlatform get instance => _instance;

  static set instance(MessageServicePlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  void addMessageListener(MessageEventSink sink);

  void removeMessageListener(MessageEventSink sink);

  Future<VoidResult> sendPassThroughMessage(String roomUuid, String userUuid, String data);
}