import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:netease_common/netease_common.dart';
import 'package:netease_roomkit_interface/netease_roomkit_interface.dart';

import '../method_channel/method_channel_preview_room_rtc_controller.dart';

abstract class PreviewRoomRtcControllerPlatform extends PlatformInterface{
  static final Object _token = Object();

  PreviewRoomRtcControllerPlatform() : super(token: _token);

  static PreviewRoomRtcControllerPlatform _instance = MethodChannelPreviewRoomRtcController();

  static PreviewRoomRtcControllerPlatform get instance => _instance;

  static set instance(PreviewRoomRtcControllerPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  Future<VoidResult> startPreview();

  Future<VoidResult> stopPreview();

  Future<VoidResult> switchCamera();

  Future<VoidResult> addBeautyFilter(String path);

  Future<VoidResult> addBeautySticker(String path);

  Future<VoidResult> enableBeauty(bool isOpenBeauty);

  Future<VoidResult> removeBeautyFilter();

  Future<VoidResult> removeBeautySticker();

  Future<VoidResult> startBeauty();

  Future<VoidResult> stopBeauty();

  Future<VoidResult> setBeautyFilterLevel(double level);

  Future<VoidResult> setBeautyEffect(NERoomBeautyEffectType beautyType, double level);

}