import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:netease_roomkit_interface/netease_roomkit_interface.dart';
import 'package:netease_roomkit_interface/src/method_channel/method_channel_chat_controller.dart';
import 'package:netease_common/netease_common.dart';

abstract class RoomChatControllerPlatform extends PlatformInterface{
  static final Object _token = Object();

  RoomChatControllerPlatform() : super(token: _token);

  static RoomChatControllerPlatform _instance = MethodChannelChatController();

  static RoomChatControllerPlatform get instance => _instance;

  static set instance(RoomChatControllerPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  Future<VoidResult> joinChatroom(String roomUuid);

  Future<VoidResult> leaveChatroom(String roomUuid);

  Future<VoidResult> sendBroadcastTextMessage(String roomUuid,String message);

  Future<VoidResult> sendDirectTextMessage(String roomUuid,String userUuid,String message);

  Future<VoidResult> sendGroupTextMessage(String roomUuid,List<String> userUuids,String message );

  Future<NEResult<List<NEChatRoomMember>>> fetchChatRoomMembers(String roomUuid, NEChatroomMemberQueryType queryType, int limit);
}