import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:netease_common/netease_common.dart';
import 'package:netease_roomkit_interface/src/method_channel/method_channel_whiteboard_controller.dart';

abstract class RoomWhiteboardControllerPlatform extends PlatformInterface{
  static final Object _token = Object();

  RoomWhiteboardControllerPlatform() : super(token: _token);

  static RoomWhiteboardControllerPlatform _instance = MethodChannelWhiteboardController();

  static RoomWhiteboardControllerPlatform get instance => _instance;

  static set instance(RoomWhiteboardControllerPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  Future<VoidResult> startWhiteboardShare(String roomUuid);

  Future<VoidResult> stopWhiteboardShare(String roomUuid);

  Future<VoidResult> setEnableDraw(String roomUuid,bool enable);

  Future<VoidResult> stopMemberWhiteboardShare(String roomUuid,String userUuid);

}